// Készíts függvényt, ami pontosan 3 számot kap paraméterül, és megadja, hogy az első paratméterre igaz-e, hogy a második és a harmadik között található (határokat is beleértve).

function kozott(x, min, max) {
  // visszatérünk azzal, hogy `x` `min` és `max` között van-e
  return (x <= max) && (x >= min);
}


// Készíts függvényt, ami adott minimum és maximum érték között (határokat beleérve) állít elő egy véletlenszerű egész számot! Megoldásodhoz használd a `Math.random` függvényt!

function veletlenEgesz(min, max) {
  // véletlen szám a [0, 1) intervallumban
  const veletlen = Math.random();
  // mekkora tartományban kell a véletlen szám
  const tartomany = max - min + 1;
  // eredmény kiszámítása
  return Math.trunc(veletlen * tartomany) + min;
}

// Készíts egy olyan N×M-es mátrix adatszerkezetet (tömbök tömbje), melynek cellái 1, 2, 3 számokat tartalmaznak. Készítsünk programot, ami megszámolja, hogy melyik számból hány darab van a mátrixban!

const matrix = [
  [1, 2, 3, 1, 1],
  [1, 1, 3, 3, 3],
  [3, 2, 3, 3, 1],
  [2, 2, 1, 1, 2]
];

// Készíts függvényt, ami paraméterül kap egy N és egy M számot, valamint egy tetszőleges kezdőértéket és eredményül ad egy olyan N×M-es mátrixot, aminek minden cellájában a paraméterül kapott kezdőérték van.

function uresMatrix(N, M, ertek) {
  // létrehozunk egy üres tömböt
  let matrix = [];
  
  // soronként haladunk
  for (let y = 0; y < M; ++y) {
    // létrehozunk egy üres sort
    matrix[y] = [];
    
    // oszloponként haladunk
    for (let x = 0; x < N; ++x) {
      // feltöltjük a cellát a kezdőértékkel, ha az csak egyszerű érték lehet
      // matrix[y][x] = ertek;
      // feltöltjük a cellát a kezdőértékkel, ügyelve, hogy az akár objektum is lehet!
      matrix[y][x] = JSON.parse(JSON.stringify(ertek));
    }
  }
  
  return matrix;
}

// Készíts olyan függvényt, amely paraméterül kapja egy mátrixot és egy x, y koordinátapárt, és a megadott cella (x, y koordináták alapján) összes szomszédjának növeli eggyel az értékét.

function szomszedNovel(matrix, x, y) {
  // meghatározzuk a mátrix szélességét és magaasságát
  const N = matrix[0].length;
  const M = matrix.length;

  // minden irányba +/- 1 szomszédokat nézzük
  for (let i = -1; i <= 1; i++) {
    for (let j = -1; j <= 1; j++) {

      // Az éppen vizsgált elem koordinátái
      const xkoord = x + i;
      const ykoord = y + j;

      // vizsgáljuk, hogy nem önmagunkat akarjuk változtatni, 
      // és hogy a mátrixon belül maradtunk-e
      if (!(xkoord == x && ykoord == y) && 
          kozott(xkoord, 0, N - 1) && kozott(ykoord, 0, M - 1)) {
        // növeljük a szomszéd értékét
        // figyelhünk a helyes indexelésre!
        matrix[ykoord][xkoord] += 1;
      }
    }
  }
}